// Author 		: F. de la Parra
// Date			: January, 2019
// Description 	: This program exercises for loops and formatted
//				  console output.
// Version		: 1.0

import java.util.Scanner;
import java.util.Random;

public class JavaDemo1 {
	
	
	// Method "main" drives topic selection
	
	public static void main(String[] args) {
		JavaDemo1 demoObject = new JavaDemo1();
		
		// Display menu and wait for a menu item selection
		
		Scanner menuSelect = new Scanner(System.in);
		
		// Initialize menuItem selection.
		int menuItem = 0;
		
		while (menuItem != 9) {
			// Display menu
			System.out.println("\n***JavaDemo1 Menu ***");
			System.out.println("1 - for loops");
			System.out.println("2 - Formatted console output");
			System.out.println("9 - Exit");
			System.out.println();
			System.out.println("Enter demo number:");
			
			// Input a menu selection.
			menuItem = menuSelect.nextInt();
			
			// Run demo corresponding to selected menu item.
			switch (menuItem) {
				
				case 1 : {
					System.out.println("\n*** Running for loops demo ***\n");
					
					// Execute array demo.
					demoObject.forLoopDemo();
					break;
				}
				
				case 2 : {
					System.out.println("\n*** Running formatted console output demo ***\n");
					
					// Execute random numbers in range demo.
					demoObject.formattedOutputDemo();
					break;
				}
				
			 // case n :     More upcoming demos ...
				
				default : {
					if (menuItem != 9)
						System.out.println("Invalid selection entered");
					break;
				}
			}
			if (menuItem != 9) 	
				System.out.println("\n*** Demo completed ***\n");
		}
		
		System.out.println("\n*** Program terminated ***\n");
	}
	
	// Method forLoopDemo shows examples of for loops.
	public void forLoopDemo() {
		
		// Testing general for loop.
		String p = "hello world";
		for (int i = 0, j = p.length(); (i < 5 && i < j); i++, j--) {
			System.out.println("Current phrase is: " + p.substring(i,j));
		}
		System.out.println();
		
		// Test nested for loops.
		for (int i=0; i<5; i++) {
			for (int j=i; j<5; j++) {
				System.out.print(j + " ");
			}
			System.out.println();
		}
		
		// for each loop.
		int[] nums = {1,2,3,4,5,6,7,8,9};
		int sum = 0;
		for (int item : nums)
			sum += item;
		System.out.println("\nSum is " + sum);
		
	}
	
	// Method formattedOutputDemo shows examples of formatted output.
	
	public void formattedOutputDemo() {
		
		System.out.printf("%4$1s %3$1s %2$1s %1$1s", "a", "b", "c", "d");
		System.out.printf("\nThe word is upper-cased as: %S", "hello");
		System.out.printf("%nHello world!\n");
		System.out.printf("Number of trials: %d, Average: %f", 10, 6.25);
	}

}